'
'Licensed Materials - Use restricted, please refer to the "Samples Gallery" terms and conditions in the IBM International Program License Agreement.
'
' Copyright IBM Corporation 2003, 2004. All Rights Reserved. 
'

Imports System
Imports Rational.Test.Ft
Imports Rational.Test.Ft.Object.Interfaces
Imports Rational.Test.Ft.Script
Imports Rational.Test.Ft.Value

Namespace Superscript
MustInherit Public Class HtmlScript
        Inherits ExtensionScript
        
	    ' Overrides the base implementation of onObjectNotFound.  Whenever
	    ' this event occurs, we look through all the active domains (places
	    ' where we might find objects).  For Html domains (we skip over Java 
	    ' and other domains) we find all the top objects.  If the top object
	    ' is an Html Dialog, we type an enter key at it to dismiss it.
	    ' We log a warning when this happens.
	    Public Overrides Sub OnObjectNotFound(ByVal testObjectMethodState As ITestObjectMethodState)
            If Not testObjectMethodState.GetTestObject().GetPropertyFromMap(IMapPropertyName_Fields.DOMAIN).Equals("Html")		    
			    return
		    End If

		    Dim dismissedAWindow As Boolean = False
		    Dim domains() As DomainTestObject = GetDomains()
            Dim i As Integer
		    For i=0 To domains.Length -1
			    If domains(i).GetName().Equals("Html")
				    ' We found an Html domain.
				    Dim topObjects() As TestObject = domains(i).GetTopObjects()
				    If Not topObjects Is Nothing
				        Try
                            Dim j As Integer
						    For j = 0 To topObjects.Length-1						    
							    If topObjects(j).GetProperty(".class").Equals("Html.Dialog")							    
								    ' We found a top-level HtmlDialog.
								    LogWarning("HtmlScript.onObjectNotFound - dismissing Html Dialog")
								    Try								    
									    dismissedAWindow = True
                                        Dim castTopObject as TopLevelTestObject = topObjects(j)
									    castTopObject.inputKeys("{enter}")
								    Catch e As Exception
                                    End Try
                                End If
						    Next j					    
					    Finally					    
						    ' unregister all references to top objects
						    Unregister(topObjects)
					    End Try 
                    End If				    
			    End If
		    Next i
		    If dismissedAWindow		 
			    ' try again - we may have unblocked the problem!
			    testObjectMethodState.FindObjectAgain()
		    Else		    
			    LogWarning("HtmlScript.onObjectNotFound - found no Html Dialog to dismiss")
            End If
        End Sub 'OnObjectNotFound

	    Public Sub CloseBrowser(ByVal testObject As BrowserTestObject)	    
		    Dim sName As String = testObject.GetProperty(".browserName")
		    testObject.Close()							
		    If Not sName.Equals("MS Internet Explorer") 		    
			    Dim proc As ProcessTestObject = testObject.GetProcess()
			    While (proc.IsAlive())
				    Sleep(1)
                End While
		    End If
	    End Sub 'CloseBrowser

    End Class 'HtmlScript
End Namespace 'SuperScript

